import { NestedSetProperties } from './nested-set-properties';
export declare class NestedSetNode implements NestedSetProperties {
    depth: number;
    left: number;
    right: number;
    title: string;
    children: NestedSetNode[];
    parent: NestedSetNode | null;
    constructor(title?: string, left?: number, right?: number, depth?: number, parent?: NestedSetNode);
    isLeaf(): boolean;
    isRoot(): boolean;
    prevSibling(): NestedSetNode | null;
    nextSibling(): NestedSetNode | null;
    countNextSiblings(): number;
    getSize(): number;
    append(node: NestedSetNode): void;
    prepend(node: NestedSetNode): void;
    rebuild(list?: NestedSetNode[]): NestedSetNode[];
    toNestedSetProperties(): NestedSetProperties;
    flat(): NestedSetProperties[];
    removeChild(child: NestedSetNode): void;
    validate(): void;
}
